Debian package management: can't specify a repository (ex: "-t wheezy-backports")
Status: Rejected   

Priority: N/A   

Assignee: Alexis Mousset   

Category: Techniques   

Target version: 3.1.22   

Pull Request: https://github.com/Normation/rudder-tech

niques/pull/452

Priority: 59

Severity: Major - prevents use of part of Rudder |

no simple workaround

Name check:  

UX impact:  Fix check:  

User visibility: Getting started - demo | first install | level

1 Techniques

Regression:  

Effort required:    

Description

Steps to reproduce with Rudder 2.10.2:

- Create a directive "APT package manager configuration" (1.0) with the following parameters:

- Check "Also add the following package repositories"

- Repository 1: URL = http://debian.proxad.net/debian, distribution = wheezy-backports, Use main = Yes

- Create a directive "Package management for Debian / Ubuntu / APT systems" (2.0) with the following parameters:

- Define package version to install: use criteria below

- Package name: rsyslog

- Packet version match: == (or >=)

- Packet version number: 7.6.3

Assign both directives to the same rule targeting a node running Debian 7.5.

The directives stay in the status "Repaired", 0%, with the following details:

Performed repair action for deb package rsyslog with policy: update

Related issues:

Related to Rudder - Bug #5244: Technique 'Package management for RHEL / CentO... Rejected 2014-07-08

Related to Rudder - Bug #4999: Technique rpmPackageInstallation: Specified ve... Released 2014-06-11

Related to Rudder - Bug #10241: "Package management" technique missing "allow... Released

History

#1 - 2014-06-18 18:42 - Olivier Chédru

Note the Debian repository is properly set in /etc/apt/sources.list.d/rudder-apt.list, but the package is not upgraded.

#2 - 2014-07-10 16:55 - Nicolas PERRON

As far I can see, your repaired status could be due to CFEngine trying to compare a version not matched. The installed version is not ok and older

than the promised one, then CFEngine will try to update.

Trying to update could fail/succeed but will send a repaired report. It seems to be the same problem than #5244.

#3 - 2014-07-10 17:23 - Nicolas PERRON

The repository you added seems to have rsyslog 7.6.3 but still not having all required dependencies:

[...]

 rsyslog depends on libc6 (>= 2.17); however:

  Version of libc6:amd64 on system is 2.13-38+deb7u1.

 rsyslog depends on libestr0 (>= 0.1.4); however:

  Version of libestr0 on system is 0.1.1-2.

[...]

 Maybe this is why rsyslog is never updated. Did you try manually to check if it was possible ?
#4 - 2014-07-10 17:28 - Olivier Chédru

Yes, it was OK.

I used the following manual procedure to upgrade rsyslog on a freshly installed Debian 7.5:

echo "deb http://debian.proxad.net/debian wheezy-backports main" >> /etc/apt/sources.list

apt-get update

apt-get -y -t wheezy-backports install rsyslog

#5 - 2014-07-15 17:29 - Nicolas PERRON

- Status changed from New to Discussion

- Assignee set to Jonathan CLARKE

- Target version set to 2.6.17

The problem is that "Package management for Debian / Ubuntu / APT systems" is not able to manage packages with backport repositories.

APT needs to be configured in order to use backports by default. For example, adding a file /etc/apt/apt.conf.d/myconf containing:

APT::Default-Release "wheezy-backports";

 I see two options:

- Add new version of "APT package manager configuration" to add custom configuration into APT (a textbox where options could be added into

/etc/apt/apt.conf.d/99rudder). It seems to me that this is the simpliest way and it's flexible.

- Add new version of  "Package management for Debian / Ubuntu / APT systems" to add an option if we want to use a backport or not. It seems to me

that this is more complex as different package_method would be used in function of being installed by backport or not.

What's your opinion Jon ?

#6 - 2014-07-15 17:43 - Jonathan CLARKE

- Assignee changed from Jonathan CLARKE to Nicolas PERRON

I don't think it's a good idea to change the settings on hosts for apt via a config file. This could have undesired side effects.

However, using the "-t" option as in Olivier's example above looks great.

Sure, it would require a new package_method, but we could pass a parameter to the package method to specify the name to use.

#7 - 2014-07-25 19:23 - Nicolas PERRON

- Assignee changed from Nicolas PERRON to Jonathan CLARKE

- % Done changed from 0 to 100

- Pull Request set to https://github.com/Normation/rudder-techniques/pull/452

I've made a Pull Request: https://github.com/Normation/rudder-techniques/pull/452

Jon, would you like to review it ?

#8 - 2014-08-11 12:52 - Nicolas PERRON

- Target version changed from 2.6.17 to 2.6.18

#9 - 2014-10-06 17:26 - Matthieu CERDA

- Target version changed from 2.6.18 to 2.6.19

#10 - 2014-11-13 16:34 - Vincent MEMBRÉ

- Target version changed from 2.6.19 to 2.6.20

#11 - 2015-02-03 20:45 - François ARMAND

- Assignee changed from Jonathan CLARKE to Benoît PECCATTE

- Target version changed from 2.6.20 to 2.10.10

Benoit, could you take a look at that one please (on 2.10).

#12 - 2015-02-05 17:37 - Vincent MEMBRÉ
- Target version changed from 2.10.10 to 2.10.11

#13 - 2015-03-05 16:08 - Benoît PECCATTE

- Category set to Techniques

#14 - 2015-03-05 21:50 - Vincent MEMBRÉ

- Target version changed from 2.10.11 to 2.10.12

#15 - 2015-03-19 18:33 - Vincent MEMBRÉ

- Target version changed from 2.10.12 to 2.10.13

#16 - 2015-04-10 10:18 - Vincent MEMBRÉ

- Target version changed from 2.10.13 to 2.10.14

#17 - 2015-05-19 12:01 - Vincent MEMBRÉ

- Target version changed from 2.10.14 to 2.10.15

#18 - 2015-07-07 22:28 - Vincent MEMBRÉ

- Target version changed from 2.10.15 to 2.10.16

#19 - 2015-08-12 10:41 - Vincent MEMBRÉ

- Target version changed from 2.10.16 to 2.10.17

#20 - 2015-09-22 14:21 - Vincent MEMBRÉ

- Target version changed from 2.10.17 to 2.10.18

#21 - 2015-10-16 14:59 - Vincent MEMBRÉ

- Target version changed from 2.10.18 to 2.10.19

#22 - 2015-10-27 15:43 - Vincent MEMBRÉ

- Target version changed from 2.10.19 to 2.10.20

#23 - 2015-12-09 16:55 - Vincent MEMBRÉ

- Target version changed from 2.10.20 to 277

#24 - 2015-12-09 16:57 - Vincent MEMBRÉ

- Target version changed from 277 to 2.11.18

#25 - 2016-01-20 23:33 - Vincent MEMBRÉ

- Target version changed from 2.11.18 to 2.11.19

#26 - 2016-03-01 15:45 - Vincent MEMBRÉ

- Target version changed from 2.11.19 to 2.11.20

#27 - 2016-04-08 16:50 - Vincent MEMBRÉ

- Target version changed from 2.11.20 to 2.11.21

#28 - 2016-05-24 23:48 - Vincent MEMBRÉ

- Target version changed from 2.11.21 to 2.11.22

#29 - 2016-06-02 18:21 - Vincent MEMBRÉ

- Target version changed from 2.11.22 to 2.11.23

#30 - 2016-07-29 15:16 - Vincent MEMBRÉ

- Target version changed from 2.11.23 to 2.11.24

#31 - 2016-08-27 12:03 - Vincent MEMBRÉ
- Target version changed from 2.11.24 to 308

#32 - 2016-09-12 12:00 - Vincent MEMBRÉ

- Target version changed from 308 to 3.1.14

#33 - 2016-09-28 22:51 - Vincent MEMBRÉ

- Target version changed from 3.1.14 to 3.1.15

#34 - 2016-10-03 12:14 - Vincent MEMBRÉ

- Target version changed from 3.1.15 to 3.1.16

#35 - 2016-10-11 15:13 - Vincent MEMBRÉ

- Target version changed from 3.1.16 to 3.1.17

#36 - 2016-12-05 15:21 - Vincent MEMBRÉ

- Target version changed from 3.1.17 to 3.1.18

#37 - 2017-02-17 23:21 - Vincent MEMBRÉ

- Target version changed from 3.1.18 to 3.1.19

#38 - 2017-04-03 15:08 - François ARMAND

- Related to Bug #10241: "Package management" technique missing "allow untrusted" switch added

#39 - 2017-04-03 15:08 - François ARMAND

- Severity set to Major - prevents use of part of Rudder | no simple workaround

- User visibility set to Getting started - demo | first install | level 1 Techniques

- Priority set to 0

#40 - 2017-04-14 17:09 - Vincent MEMBRÉ

- Target version changed from 3.1.19 to 3.1.20

#41 - 2017-04-25 10:18 - Jonathan CLARKE

- Status changed from Discussion to New

#42 - 2017-04-25 10:19 - Jonathan CLARKE

- Assignee deleted (Benoît PECCATTE)

#43 - 2017-04-25 14:22 - Jonathan CLARKE

- Subject changed from Debian package management; unable to upgrade package to version on repo wheezy-backports to Debian package

management: can't specify a repository (ex: "-t wheezy-backports")

- Priority changed from 0 to 45

#44 - 2017-04-25 18:19 - Alexis Mousset

- Assignee set to Alexis Mousset

#45 - 2017-05-18 23:12 - Vincent MEMBRÉ

- Target version changed from 3.1.20 to 3.1.21

#46 - 2017-06-15 10:52 - Vincent MEMBRÉ

- Target version changed from 3.1.21 to 3.1.22

#47 - 2017-06-26 18:43 - Benoît PECCATTE

- Priority changed from 45 to 58

#48 - 2017-08-04 19:30 - Alexis Mousset

- Status changed from New to Rejected
- Priority changed from 58 to 59

Fixed in #10241 for the "Package" technique, closing.

It is now possible to pass arbitrary options to apt.
